// file: $USFS/class/image_analysis/v3.1/imaga_cstr_0.cc
//

// isip include files
//
#include "image_analysis.h"

#include "image_analysis_constants.h"

// method: default destructor
//
// arguments: none
//
// return: none
//
Image_analysis::~Image_analysis() {
  
  // general data needing cleanup
  //
  if (param_version_d != (char_1*)NULL) {
    delete [] param_version_d;
  }
  
  if (param_fname_d != (char_1*)NULL) {
    delete [] param_fname_d;
  }

  if (model_version_d != (char_1*)NULL) {
    delete [] model_version_d;
  }

  if (model_fname_d != (char_1*)NULL) {
    delete [] model_fname_d;
  }

  if (model_name_d != (char_1*)NULL) {
    delete [] model_name_d;
  }

  if (sel_vec_d != (int_4*)NULL) {
    delete [] sel_vec_d;
  }
  
  // histogram-related parameters needing cleaning
  //
  if (hist_r_rpdf_d != (float_8*)NULL) {
    delete [] hist_r_rpdf_d;
  }
  
  if (hist_r_gpdf_d != (float_8*)NULL) {
    delete [] hist_r_gpdf_d;
  }
  
  if (hist_r_bpdf_d != (float_8*)NULL) {
    delete [] hist_r_bpdf_d;
  }

  if (hist_r_ylwpdf_d != (float_8*)NULL) {
    delete [] hist_r_ylwpdf_d;
  }
  
  if (hist_r_brnpdf_d != (float_8*)NULL) {
    delete [] hist_r_brnpdf_d;
  }
  
  if (hist_r_rcval_d != (float_8*)NULL) {
    delete [] hist_r_rcval_d;
  }
  
  if (hist_r_gcval_d != (float_8*)NULL) {
    delete [] hist_r_gcval_d;
  }
  
  if (hist_r_bcval_d != (float_8*)NULL) {
    delete [] hist_r_bcval_d;
  }
  
  if (hist_r_ylwcval_d != (float_8*)NULL) {
    delete [] hist_r_ylwcval_d;
  }
  
  if (hist_r_brncval_d != (float_8*)NULL) {
    delete [] hist_r_brncval_d;
  }
  
  if (hist_t_rpdf_d != (float_8*)NULL) {
    delete [] hist_t_rpdf_d;
  }
  
  if (hist_t_gpdf_d != (float_8*)NULL) {
    delete [] hist_t_gpdf_d;
  }
  
  if (hist_t_bpdf_d != (float_8*)NULL) {
    delete [] hist_t_bpdf_d;
  }

  if (hist_t_ylwpdf_d != (float_8*)NULL) {
    delete [] hist_t_ylwpdf_d;
  }
  
  if (hist_t_brnpdf_d != (float_8*)NULL) {
    delete [] hist_t_brnpdf_d;
  }

  if (hist_t_rcval_d != (float_8*)NULL) {
    delete [] hist_t_rcval_d;
  }
  
  if (hist_t_gcval_d != (float_8*)NULL) {
    delete [] hist_t_gcval_d;
  }
  
  if (hist_t_bcval_d != (float_8*)NULL) {
    delete [] hist_t_bcval_d;
  }

  if (hist_t_ylwcval_d != (float_8*)NULL) {
    delete [] hist_t_ylwcval_d;
  }
  
  if (hist_t_brncval_d != (float_8*)NULL) {
    delete [] hist_t_brncval_d;
  }

  if (edge_r_lpdf_d != (float_8*)NULL) {
    delete [] edge_r_lpdf_d;
  }
  
  if (edge_r_lcval_d != (float_8*)NULL) {
    delete [] edge_r_lcval_d;
  }
  
  if (edge_t_lpdf_d != (float_8*)NULL) {
    delete [] edge_t_lpdf_d;
  }
  
  if (edge_t_lcval_d != (float_8*)NULL) {
    delete [] edge_t_lcval_d;
  }

  if (pca_t_data_d != (float_4*)NULL) {
    delete [] pca_t_data_d;
  }

  if (covar_t_data_d != (float_4*)NULL) {
    delete [] covar_t_data_d;
  }
  
  if (mean_t_data_d != (float_4*)NULL) {
    delete [] mean_t_data_d;
  }

  if (dent_t_red_d != (float_8*)NULL) {
    delete [] dent_t_red_d;
  }

  if (dent_t_grn_d != (float_8*)NULL) {
    delete [] dent_t_grn_d;
  }
  
  if (dent_t_blu_d != (float_8*)NULL) {
    delete [] dent_t_blu_d;
  }

  if (huf_r_rpdf_d != (float_8*)NULL) {
    delete [] huf_r_rpdf_d;
  }

  if (huf_r_gpdf_d != (float_8*)NULL) {
    delete [] huf_r_gpdf_d;
  }
  
  if (huf_r_bpdf_d != (float_8*)NULL) {
    delete [] huf_r_bpdf_d;
  }

  if (rle_r_cos_d != (float_4**)NULL) {
    for (int_4 i = 0; i < IMAGA_BLK_SIZE; i++) {
      if (rle_r_cos_d[i] != (float_4*)NULL) {
	delete [] rle_r_cos_d[i];
      }
    }
    delete [] rle_r_cos_d;
  }

  if (rle_r_red_d != (float_4*)NULL) {
    delete [] rle_r_red_d;
  }

  if (rle_r_grn_d != (float_4*)NULL) {
    delete [] rle_r_grn_d;
  }
  
  if (rle_r_blu_d != (float_4*)NULL) {
    delete [] rle_r_blu_d;
  }

  // exit gracefully
  //
}






