// file: $USFS/class/image_analysis/v3.0/imaga_diff_07.cc
//

// system include files
//
#include <memory.h>

// isip include files
//
#include "image_analysis.h"
#include <integral_constants.h>

// method: dent_init_cc
//
// arguments: none
//
// return: a logical_1 value indicating status
//
// this method initializes the histogram computation.
//
logical_1 Image_analysis::dent_init_cc() {
  
  // deallocate memory if necessary
  //
  if (dent_t_red_d != (float_8*)NULL) {
    delete [] dent_t_red_d;
    dent_t_red_d = (float_8*)NULL;
  }
  
  if (dent_t_grn_d != (float_8*)NULL) {
    delete [] dent_t_grn_d;
    dent_t_grn_d = (float_8*)NULL;
  }
  
  if (dent_t_blu_d != (float_8*)NULL) {
    delete [] dent_t_blu_d;
    dent_t_blu_d = (float_8*)NULL;
  }
  
  // allocate memory and clear
  //
  dent_t_red_d = new float_8[dent_r_nbins_d];
  dent_t_grn_d = new float_8[dent_r_nbins_d];
  dent_t_blu_d = new float_8[dent_r_nbins_d];
  
  memset((void*)dent_t_red_d, (int)0, (size_t)(dent_r_nbins_d*sizeof(float_8)));
  memset((void*)dent_t_grn_d, (int)0, (size_t)(dent_r_nbins_d*sizeof(float_8)));
  memset((void*)dent_t_blu_d, (int)0, (size_t)(dent_r_nbins_d*sizeof(float_8)));
  
  // clear counters
  //
  dent_r_npxls_d = (int_4)0;
  dent_r_nimages_d = (int_4)0;
  dent_t_sumred_d = 0;
  dent_t_sumgrn_d = 0;
  dent_t_sumblu_d = 0;
  
  // exit gracefully
  //
  return ISIP_TRUE;
}
