// file: $USFS/class/image_analysis/v3.0/imaga_ent_04.cc
//

// isip include files
//
#include "image_analysis.h"

#include "image_analysis_constants.h"
#include <integral_constants.h>

// method: ent_mean_cc
//
// arguments:
//  uint_1* b_red: (input) red buffer
//  uint_1* b_green: (input) green buffer
//  uint_1* b_blue: (input) blue buffer
//  int_4 npixels_a: (input) number of pixels
//
// return: a logical_1 value indicating the status
//
// this method finds the mean of the total image
//
logical_1 Image_analysis::ent_assign_cc(uint_1* b_red, uint_1* b_green,
				     uint_1* b_blue, int_4 npixels_a) {
  
  // declare local variables
  //
  int_4 index_r;
  int_4 index_g;
  int_4 index_b;
  
  // loop over all the data to sum the pixel values
  // 
  for (int_4 i=0; i<npixels_a; i++) {
    
    // assign the pixels to the bins equal to the value of the color
    //
    index_r = b_red[i];
    huf_r_rpdf_d[index_r]++;
    index_g = b_green[i];
    huf_r_gpdf_d[index_g]++;
    index_b = b_blue[i];
    huf_r_bpdf_d[index_b]++;
    
    // increment the pixels
    //
    huf_r_npxls_d++;
  }
  
  // exit gracefully
  //
  return ISIP_TRUE;
}
 
