// file: $USFS/class/image_analysis/v3.0/imaga_rle_02.cc
//

// isip include files
//
#include "image_analysis.h"

#include <integral_constants.h>

// method: train_cc
//
// arguments:
//  char_1* image_fname_a: (input) the image filename
//
// return: a logical_1 value indicating status
//
// this method computes the standard deviation in the training mode
//
logical_1 Image_analysis::rle_train_cc(char_1* image_fname_a) {
  
  // compute the standard deviaiton
  //
  if (rle_compute_cc(image_fname_a) == ISIP_FALSE) {
    error_handler_cc((char_1*)"ent_train_cc",
		     (char_1*)"error while computing the entropy");
    return ISIP_FALSE;
  }

  // provide some debugging information
  //
  if (debug_level_d > ISIP_DEBUG_BRIEF) {
    fprintf(stdout, "<%s> %s = %ld\n", "Image_analysis::rle_compute_cc",
	    "rle_npxls", rle_r_npxls_d);
    fprintf(stdout, "<%s> %s = %ld\n", "Image_analysis::rle_compute_cc",
	    "rle_r_nimages_d", rle_r_nimages_d);
  }
  
  // exit gracefully
  //
  return ISIP_TRUE;
}
    
