// file: $USFS/class/image_analysis/v3.0/imaga_sd_09.cc
//

// isip include files
//
#include "image_analysis.h"
#include <integral_constants.h>

// method: sd_normalize_cc
//
// arguments: none
//
// return: a logical_1 value indicating status
//
// this method normalizes a histogram
//
logical_1 Image_analysis::sd_normalize_cc() {
  
  // declare a scaling constant
  //
  if (sd_r_npxls_d == (int_4)0) {
    error_handler_cc((char_1*)"sd_normalize_cc",
		     (char_1*)"no data to be normalized");
    return ISIP_FALSE;
  }

  float_8 scale = 1.0 / (float_8)sd_r_npxls_d;
  
  // normalize
  //
  sd_t_red_d *= scale;
  sd_t_grn_d *= scale;
  sd_t_blu_d *= scale;
  
  // exit gracefully
  //
  return ISIP_TRUE;
}



